import numba as nb
from numba.rewrites import Rewrite, register_rewrite
from numba import ir

@register_rewrite('before-inference')
class MyRewrite(Rewrite):
    
    def match(self, func_ir, block, typemap, calltypes):
            assigns = [
                assign
                for assign in block.find_insts(ir.Assign)
                if assign.target.name == 'meaningful_var'
            ]

            if len(assigns) > 0 and not hasattr(self, 'assigns'):
                self.assigns = assigns
                self.block = block
                return True
    
    def apply(self):
        for assign in self.assigns:
            # replace with 42
            assign.value = ir.Const(42, assign.value.loc)

        return self.block
        
@nb.jit(nopython=True)
def test(x):
    meaningful_var = '#to be replaced#'
    y = meaningful_var + 1
    return y
    
print(test(1))